#ifndef _FUNCS_H
#define _FUNCS_H

#include <time.h>
#include <sys/utsname.h>

#if defined(CLOCK_BOOTTIME)
	#define CLOCK CLOCK_BOOTTIME
#elif defined(CLOCK_UPTIME)
	#define CLOCK CLOCK_UPTIME
#elif defined(__APPLE__)
	#define CLOCK CLOCK_MONOTONIC
#endif

typedef struct {
	char os_name[128];
	struct utsname uts;

	char *pkg_cmd;
	char *color;
	char *font_color;
	size_t logo_size;
	char **logo;
} FETCH;

FETCH Init(void);
int GetOs(char *os_name, size_t len);
void GetArt(FETCH *fetch);
void GetKernel(const char *title, const FETCH fetch);
void PrintOs(const char *title, const FETCH fetch);
void PrintColors(const char *title, const FETCH fetch);
void Blank(const char *title, const FETCH fetch);

#endif
